<?php

namespace Teknisa\PED\Modules\Pedidos\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Doctrine\ORM\Query\ResultSetMapping;

    class Ped05900ComposicaoPrecoProdutoFactory {
        
        protected $connection;
    
        public function __construct(EntityManager $entityManager) {
            $this->connection       = $entityManager->getConnection();
            $this->entityManager    = $entityManager;
        }
        
        public function openGridCalc($row){
            try {
                $sql = "SELECT
                    DECODE(:P_TODOSLISTA, 'T', 'N', 'S')            IDMARCADO,
                    J.CDPRODUTO,
                    J.CDARVPROD,
                    J.NMPRODUTO,
                    J.DSFORMCALCPRECO,
                    J.CDFILIAL,
                    J.NRORG,
                    ROUND(J.VRCUSTOATUAL, 2)                     VRCUSTOATUAL,
                    ROUND(J.VRCUSTOMEDIO, 2)                     VRCUSTOMEDIO,
                    J.VRITEPREBASE
                FROM
                    (
                        SELECT
                            P.CDPRODUTO,
                            P.CDARVPROD,
                            P.NMPRODUTO,
                            P.NRORG,
                            MAX(FP.DSFORMCALCPRECO)                                                               AS DSFORMCALCPRECO,
                            F.CDFILIAL,
                            CUSTO_PRODUTO(F.CDFILIAL, P.CDPRODUTO, :P_CDTIPOCUSTO, SYSDATE, SYSDATE)                  AS VRCUSTOATUAL,
                            CUSTO_PRODUTO(F.CDFILIAL, P.CDPRODUTO, '6', SYSDATE, SYSDATE)                             AS VRCUSTOMEDIO,
                            SUM(DECODE(VRPEFORMPREC, 0, ROUND(CUSTO_PRODUTO(F.CDFILIAL, P.CDPRODUTO, :P_CDTIPOCUSTO, SYSDATE, SYSDATE) +(DECODE(I.
                            IDITFORPRECO, 'A', FP.VRFATFORMPREC, FP.VRFATFORMPREC *(- 1))),
                                                              2),
                                       ROUND(CUSTO_PRODUTO(F.CDFILIAL, P.CDPRODUTO, :P_CDTIPOCUSTO, SYSDATE, SYSDATE) +(CUSTO_PRODUTO(F.CDFILIAL,
                                       P.CDPRODUTO, :P_CDTIPOCUSTO, SYSDATE, SYSDATE) *((DECODE(I.IDITFORPRECO, 'A', FP.VRPEFORMPREC, FP.VRPEFORMPREC *(-
                                       1))) / 100)),
                                             2)))                                                                                AS VRITEPREBASE
                        FROM
                            PRODUTO       P,
                            FILIAL        F,
                            PRODFILI      PF,
                            ITFORMPRECO   I,
                            FORMPRECPROD  FP
                        WHERE
                            ( ( P.CDARVPROD BETWEEN :P_CDARVPRODINI AND :P_CDARVPRODFIN )
                              OR ( :P_TTCDPRODUTO = 'T' ) )
                            AND ( ( P.CDPRODUTO = :P_CDPRODUTO )
                                  OR ( :P_TCDPRODUTO = 'T' ) )
                            AND ( F.CDFILIAL = :P_CDFILIAL )
                            AND ( F.CDFILIAL = PF.CDFILIAL )
                            AND ( P.CDPRODUTO = PF.CDPRODUTO )
                            AND ( FP.CDPRODUTO = P.CDPRODUTO )
                            AND ( FP.CDFILIAL = F.CDFILIAL )
                            AND ( I.CDITFORPRECO = FP.CDITFORPRECO )
                            AND ( FP.CDFILIAL = PF.CDFILIAL )
                            AND ( P.CDNVPRODUTO = (
                                SELECT
                                    MAX(CDNVPRODUTO)
                                FROM
                                    PRODUTO
                            ) )
                            AND ( FP.DSFORMCALCPRECO IS NOT NULL )
                        GROUP BY
                            P.CDPRODUTO,
                            P.NRORG,
                            P.CDARVPROD,
                            P.NMPRODUTO,
                            F.CDFILIAL,
                            FP.DSFORMCALCPRECO
                        ORDER BY
                            P.CDARVPROD
                    ) J
                ORDER BY
                    J.CDARVPROD";

                $params = array(
                    'P_CDFILIAL'        => $row[0]['CDFILIAL'],
                    'P_CDPRODUTO'       => $row[0]['CDPRODUTO'],
                    'P_CDARVPRODINI'    => $row[0]['CDARVPRODINI'],
                    'P_CDARVPRODFIN'    => $row[0]['CDARVPRODFIN'],
                    'P_CDTIPOCUSTO'     => $row[0]['CDTIPOCUSTO'],
                    'P_TODOSLISTA'      => $row[0]['TODOSLISTA'],
                    'P_TTCDPRODUTO'     => 'T',
                    'P_TCDPRODUTO'      => 'T'
                );

                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return $std->fetchAll();
                
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function getComposicao($produto){
            try {
                $sql = "SELECT
                            F.NRORG,
                            F.CDFILIAL,
                            F.CDPRODUTO,
                            F.CDITFORPRECO,
                            NVL(F.VRPEFORMPREC, 0)          AS VRPEFORMPREC,
                            NVL(F.VRFATFORMPREC, 0)         AS VRFATFORMPREC,
                            I.NMITFORPRECO,
                            I.SGITFORPRECO,
                            I.IDITFORPRECO,
                            F.DSFORMCALCPRECO
                        FROM
                            FORMPRECPROD  F,
                            ITFORMPRECO   I
                        WHERE
                            ( F.CDFILIAL = :P_CDFILIAL )
                            AND ( F.CDPRODUTO = :P_CDPRODUTO )
                            AND ( I.CDITFORPRECO = F.CDITFORPRECO )";
                        
                $params = array(
                    'P_CDFILIAL'     => $produto['CDFILIAL'],
                    'P_CDPRODUTO'    => $produto['CDPRODUTO']
                    );
                    
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return $std->fetchAll();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function getPrecobase($row){
            try {
                $sql = "SELECT
                           CDPRECOBASE
                        FROM
                           PRECOBASE
                        WHERE ((INSTR(:P_CDPRECOBASE,CDPRECOBASE) > 0) OR (:P_TCDPRECOBASE = 'T'))";
                        
                $params = array(
                    'P_CDPRECOBASE'  => null,
                    'P_TCDPRECOBASE' => $row
                );
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return $std->fetchAll();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        const UPDATE_FORMULA_COMP_PRECO = "UPDATE FORMPRECPROD
                                            SET
                                               DSFORMCALCPRECO = :P_DSFORMCALCPRECO
                                            WHERE
                                               CDPRODUTO = :P_CDPRODUTO 
                                               AND CDFILIAL  = :P_CDFILIAL";
        
        public function updateForm($row){
            try {
                $params = array(
                    'P_DSFORMCALCPRECO' => $row[0]['DSFORMCALCPRECO'],
                    'P_CDPRODUTO'       => $row[0]['CDPRODUTO'],
                    'P_CDFILIAL'        => $row[0]['CDFILIAL']
                );
                
                    
                return $this->entityManager->getConnection()->executeQuery(self::UPDATE_FORMULA_COMP_PRECO, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function precoOpcio($prod){
            
            try {
                $sql = "SELECT MAX(DTINIVALIPB) AS DTINIVALIPB
                         FROM OPCIOPRBASE
                         WHERE (CDPRODUTO   = :P_CDPRODUTO)
                            AND (CDPRECOBASE = :P_CDPRECOBASE)";
                
                $params = array(
                    'P_CDPRODUTO'       => $prod['CDPRODUTO'],
                    'P_CDPRECOBASE'        => $prod['CDPRECOBASE']
                );
                
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return $std->fetchAll();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        const UPDATE_PRECOPCIO = "UPDATE OPCIOPRBASE
                                   SET DTINIVALIPB  = :P_DTINIVALIPB,
                                       DTULTATU     = :P_DTINIVALIPB,
                                       CDOPERULTATU = :P_CDOPER
                                 WHERE CDPRECOBASE  = :P_CDPRECOBASE
                                   AND DTINIVALIPB  = TRUNC(TO_DATE(:OLD_DTINIVALIPB))
                                   AND CDPRODUTO    = :P_CDPRODUTO";
        
        public function updatePrecoOpcio($prod, $cdoperador, $valIni, $dtinivalid){
            try {
                $params = array(
                    'P_CDPRODUTO'       => $prod['CDPRODUTO'],
                    'P_CDPRECOBASE'     => $prod['CDPRECOBASE'],
                    'OLD_DTINIVALIPB'   => $dtinivalid,
                    'P_DTINIVALIPB'     => $valIni,
                    'P_CDOPER'          =>$cdoperador
                    
                );

                return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PRECOPCIO, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function precoProd($prod){
            
            try {
                $sql = "SELECT
                           CDPRECOBASE,
                           DTINIVALIPB,
                           CDPRODUTO,
                           VRITEPREBASE,
                           DTHRATZIPB,
                           CDOPERATZIPB,
                           VRCUSTPRODBASE
                        FROM
                           ITEMPREBASE
                        WHERE
                           (CDPRODUTO   = :P_CDPRODUTO  ) AND
                           (CDPRECOBASE = :P_CDPRECOBASE)";
                        
                $params = array(
                    'P_CDPRECOBASE'  => $prod['CDPRECOBASE'],
                    'P_CDPRODUTO'    => $prod['CDPRODUTO']
                    );
                    
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return $std->fetchAll();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        const INSERT_PRECO_PRODUTO = "INSERT INTO ITEMPREBASE
                                                (CDPRECOBASE,
                                                DTINIVALIPB,
                                                CDPRODUTO,
                                                VRITEPREBASE,
                                                VRCUSTPRODBASE,
                                                DTHRATZIPB,
                                                CDOPERATZIPB)
                                             VALUES (:P_CDPRECOBASE,
                                                    :P_DTINIVALIPB,
                                                    :P_CDPRODUTO,
                                                    :P_VRITEPREBASE,
                                                    :P_VRCUSTPRODBASE,
                                                    :P_DTHRATZIPB,
                                                    :P_CDOPERATZIPB)";
        
        public function insertPrecoProd($prod,$cdoperador, $valIni, $data){
            try {
                $params = array(
                    'P_CDPRECOBASE'    =>  $prod['CDPRECOBASE'],
                    'P_DTINIVALIPB'    =>  $valIni,
                    'P_CDPRODUTO'      =>  $prod['CDPRODUTO'],
                    'P_VRITEPREBASE'   =>  $prod['VRITEPREBASE'],
                    'P_VRCUSTPRODBASE' =>  $prod['VRCUSTOATUAL'],
                    'P_DTHRATZIPB'     =>  $data,
                    'P_CDOPERATZIPB'   =>  $cdoperador
                );

                return $this->entityManager->getConnection()->executeQuery(self::INSERT_PRECO_PRODUTO, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        const UPDATE_PRECO_PRODUTO = "UPDATE ITEMPREBASE
                                        SET
                                            VRITEPREBASE   = :P_VRITEPREBASE,
                                            VRCUSTPRODBASE = :P_VRCUSTPRODBASE
                                        WHERE CDPRODUTO = :P_CDPRODUTO 
                                            AND CDPRECOBASE  = :P_CDPRECOBASE
                                            AND DTINIVALIPB  = :P_DTINIVALIPB";
        
        public function updatePrecoProd($prod, $valIni){
            try {

                $params = array(
                    'P_VRITEPREBASE'   =>  $prod['VRITEPREBASE'],
                    'P_VRCUSTPRODBASE' =>  $prod['VRCUSTOATUAL'],
                    'P_DTINIVALIPB'    =>  $valIni,
                    'P_CDPRODUTO'      =>  $prod['CDPRODUTO'],
                    'P_CDPRECOBASE'    =>  $prod['CDPRECOBASE']
                );
                return $this->entityManager->getConnection()->executeQuery(self::UPDATE_PRECO_PRODUTO, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function histCustProd($prod){
            
            try {
                $sql = "SELECT VRHISCUSTOPROD, VRHISPRECOPROD
                            FROM HISTCUSTOPROD
                        WHERE CDFILIALHIST  = :P_CDFILIALHIST
                            AND CDPRODUTOHIST = :P_CDPRODUTOHIST";
                        
                $params = array(
                    'P_CDFILIALHIST'     =>  $prod['CDFILIAL'],
                    'P_CDPRODUTOHIST'    =>  $prod['CDPRODUTO']
                );
                    
                $std = $this->connection->prepare($sql);
                $std->execute($params);
                return $std->fetchAll();
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        const UPDATE_HISTCUSTPROD = "UPDATE HISTCUSTOPROD
                                         SET VRHISCUSTOPROD = :P_VRHISCUSTOPROD,
                                              VRHISPRECOPROD = :P_VRHISPRECOPROD
                                        WHERE CDFILIALHIST   = :P_CDFILIALHIST
                                          AND CDPRODUTOHIST  = :P_CDPRODUTOHIST";
        
        public function updataHistCustProd($prod){
            try {
                $params = array(
                    'P_VRHISPRECOPROD'   =>  $prod['VRITEPREBASE'],
                    'P_VRHISCUSTOPROD'   =>  $prod['VRCUSTOATUAL'],
                    'P_CDFILIALHIST'     =>  $prod['CDFILIAL'],
                    'P_CDPRODUTOHIST'    =>  $prod['CDPRODUTO']
                );

                return $this->entityManager->getConnection()->executeQuery(self::UPDATE_HISTCUSTPROD, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        const INSERE_HISTCUSTPROD = "INSERT INTO HISTCUSTOPROD
                                                (VRHISCUSTOPROD,
                                        	    VRHISPRECOPROD,
                                        	    CDFILIALHIST,
                                        	    CDPRODUTOHIST)
                                        VALUES (:P_VRHISCUSTOPROD,
                                        	    :P_VRHISPRECOPROD,
                                        	    :P_CDFILIALHIST,
                                        	    :P_CDPRODUTOHIST)";
        
        public function insereHistCustProd($prod){
            try {
                $params = array(
                    'P_VRHISPRECOPROD'   =>  $prod['VRITEPREBASE'],
                    'P_VRHISCUSTOPROD'   =>  $prod['VRCUSTOATUAL'],
                    'P_CDFILIALHIST'     =>  $prod['CDFILIAL'],
                    'P_CDPRODUTOHIST'    =>  $prod['CDPRODUTO']
                );

                return $this->entityManager->getConnection()->executeQuery(self::INSERE_HISTCUSTPROD, $params);
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        
    }
?>