/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MEDS                                                     */
/* Tabela : MEDSOLI                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 02/08/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_MEDS
BEFORE INSERT OR UPDATE OR DELETE
ON MEDSOLI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUMEDS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0)     <> NVL(:NEW.CDFILIAL,0))     OR
         (NVL(:OLD.CDPRODUTO,0)    <> NVL(:NEW.CDPRODUTO,0))    OR
         (NVL(:OLD.VRPERCMEDSOL,0) <> NVL(:NEW.VRPERCMEDSOL,0)) THEN
         :NEW.DTULTATUMEDS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('MEDSOLI', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE MEDSOLI MODIFY DTULTATUMEDS DEFAULT SYSDATE
/
