function RotaDeEntrega() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Parametrização', 'Expedição', 'Rota de Entrega']);
		geral.esperarLoading();
	};

	this.adicionar = (codigo, nome) => {
		geral.clickAndFillField('CDROTATRANS', codigo);
		geral.clickAndFillField('NMROTATRANS', nome);
	};

	this.adicionarMunicipio = (pais, estado, municipio, bairro, valorFrete) => {
		geral.searchAndClickGridFields('NMPAIS', pais,
			'NMESTADO', estado,
			'NMMUNICIPIO', municipio,
			'NMBAIRRO', bairro);
		geral.clickAndFillField('VRFRETEROTA', valorFrete);
	};

	this.adicionarCliente = (ordem, nome, endereco, cep) => {
		geral.clickAndFillField('NRORDCLIROTA', ordem);
		geral.searchAndClickGridField('NMRAZSOCCLIE', nome);
		geral.clickAndFillField('ENDERECO', endereco);
		geral.clickAndFillField('NRCEPCLIE', cep);
	};

	this.adicionarFilial = (ordem, codigoFilial, nome, endereco, cep) => {
		geral.clickAndFillField('NRORDCLIROTA', ordem);
		geral.clickAndFillField('CDFILIROTA', codigoFilial);
		geral.searchAndClickGridField('NMRAZSOCCLIE', nome);
		geral.clickAndFillField('ENDERECO', endereco);
		geral.clickAndFillField('NRCEPCLIE', cep);
	};
}
module.exports = new RotaDeEntrega();
