 ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const grupoClientesPage = require('../../../page-objects/parametrizacao/pedidos/grupoDeClientes.po.js');
const j = require('../../../json/leitorJson.po');
const grupoClientesGridId = '11835577183370944468556';
describe('Tela Grupo de Clientes', () => {
    beforeEach(() => {
        browser.get('http://erpteste.teknisa.com/login/');
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        grupoClientesPage.abrir();
    });

    afterEach(() => {
        z.component.menu.open();
        z.component.menu.clickByLabel('Sair');
        z.component.alert.clickButton('Sim');
    });

    it('Deve acessar a tela Preço do Produto', () => {
        expect(z.component.header.getTitle()).toBe('Grupo de Clientes');
    });

    it('Deve adicionar Grupo de Clientes', () => {
        geralPage.clickAdicionar();
        grupoClientesPage.adicionarGrupoClientes(j.getValor('codigo'), j.getValor('nomeGrupoCliente1'),
        j.getValor('informacaoGrupo1'), j.getValor('tabelaDesconto1'));
        geralPage.clickSalvar();
        geralPage.esperarLoading();
        expect(geralPage.gridHasText(grupoClientesGridId, j.getValor('nomeGrupoCliente1'), 1))
            .toMatch(j.getValor('nomeGrupoCliente1'));
    });

    it('Deve editar Grupo de Clientes', () => {
        geralPage.filterIt(j.getValor('nomeGrupoCliente1'));
        geralPage.esperarLoading();
        geralPage.clickGrid('NMGRUPCLIE', j.getValor('nomeGrupoCliente1'), grupoClientesGridId);
        geralPage.clickEditar();
        grupoClientesPage.editarGrupoClientes(j.getValor('nomeGrupoCliente2'),
        j.getValor('informacaoGrupo2'), j.getValor('tabelaDesconto2'));
        geralPage.clickSalvar();
        geralPage.esperarLoading();
        expect(geralPage.gridHasText(grupoClientesGridId, j.getValor('nomeGrupoCliente2'), 1))
            .toMatch(j.getValor('nomeGrupoCliente2'));
    });

    it('Excluir Cadastro', () => {
       geralPage.filterIt(j.getValor('nomeGrupoCliente2'));
       geralPage.esperarLoading();
       geralPage.clickGrid('NMGRUPCLIE', j.getValor('nomeGrupoCliente2'), grupoClientesGridId);
       grupoClientesPage.apagarGrupoClientes();
       expect(geralPage.gridHasText(grupoClientesGridId, j.getValor('nomeGrupoCliente2'), 1, false))
       .not.toMatch(j.getValor('nomeGrupoCliente2'));
    });
});
