let ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
let z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const lancamentoDePedidosPage = require('../../../page-objects/pedidos/lancamento/lancamentoDePedidos.po.js');
const j = require('../../../json/leitorJson.po');
let lancamentoDePedidosGridId = '94908493139952425301814';
describe('Tela Lançamento de Pedidos', () => {
    beforeAll(() => {
        loginPage.login(j.getValor('loginPed'), j.getValor('senhaPed'));
        lancamentoDePedidosPage.abrir();
        z.component.footer.clickRightActionByLabel('Filtrar', true);

    });

    afterAll(() => {
        geralPage.sair();
    });

    it('Deve acessar a tela Lançamento de Pedidos', () => {
        expect(z.component.header.getTitle()).toBe('Lançamento de Pedido');
    });

    it('Deve adicionar Pedido', () => {
        geralPage.clickAdicionar();
        lancamentoDePedidosPage.adicionarPedido(j.getValor('dataValida'), j.getValor('clientePed'),
            j.getValor('vendedorPed'), j.getValor('tabelaPreço'));
        geralPage.esperarLoading();
        geralPage.trocarAba('Item');
        geralPage.clickAdicionar();
        lancamentoDePedidosPage.adicionarPedido1(j.getValor('produtoN1'), j.getValor('quantidade'));
        geralPage.clickSalvar();
        geralPage.esperarLoading();
        geralPage.clickAdicionar();
        lancamentoDePedidosPage.adicionarPedido2(j.getValor('produtoN2'), j.getValor('quantidade'));
        geralPage.clickSalvar();
        geralPage.esperarLoading();
        geralPage.clickSalvarPedido();
        geralPage.clickOk();
        geralPage.esperarLoading();
        expect(geralPage.gridHasText(lancamentoDePedidosGridId, 'Aprovado', 1))
            .toEqual('Aprovado');

        expect(geralPage.gridHasText(lancamentoDePedidosGridId, j.getValor('clientePed'), 3))
            .toEqual('THE FIFTIES COMERCIO DE ALIMENTOS LTDA');

        expect(geralPage.gridHasText(lancamentoDePedidosGridId, j.getValor('vendedorPed'), 7))
            .toEqual('THE FIFTIES COMERCIO DE ALIMENTOS LTDA');


        geralPage.clickColumn(lancamentoDePedidosGridId, 0, 1, true);

        var el = element(by.css('#span-field-DSPRECOBASE > p'));
        el.getText().then(function (dsprecobase) {
            if (dsprecobase == 'THE FIFTIES') {
                console.log('Tabela de preço THE FIFTIES');
            }
            else {
                console.log('Tabela de presso é difernte de THE FIFTIES');
                z.component.footer.clickLeftActionByLabel('Voltar');
            }
        });


    });

});
